{$E-,N+,G+,F+,D-,L-}
{3d-Balls, code: BiTL/7dUMP, Special for Darkman007 ;)}
uses crt;
CONST
 VGA = $a000;

type
  Virtualscreen = Array[1..64000] of byte;
  Virscr = ^VirtualScreen;
  mas=array[1..3501] of single;
var
scr2 : virscr;
vaddr : word;
Time                : Longint ABSOLUTE $0040:$006C;
roll:single;
n:integer;
Aantal,T1:longint;


Procedure WaitVR; Assembler;
ASM
  mov  dx, 3DAh
@w1:
    in   al, dx
    test al, 8
  jnz  @w1
@w2:
    in   al, dx
    test al, 8
  jz   @w2
End;

PROCEDURE SetPixel(X,Y:Word; C:Byte;where:word);
BEGIN
     ASM
        mov ax,where
        mov es,ax
        mov bx,x
        mov dx,y
        xchg dh,dl
        mov al,c
        mov di,dx
        shr di,1
        shr di,1
        add di,dx
        add di,bx
        stosb
     END;
END;

Procedure FlipScreen(source, dest : word);
Assembler; {386 only}
asm
  mov     dx, ds
  mov     ax, [dest]
  mov     es, ax
  mov     ax, [source]
  mov     ds, ax
  xor     si, si
  xor     di, di
  mov     cx, 16000
  db      $66
  rep     movsw
  mov     ds,dx    {mov's are faster than push / pops }
end;


Procedure Clear (Col : Byte;where:word);
Assembler;
     asm
        mov     cx, 32000;
        mov     ax,where
        mov     es,ax
        xor     di,di
        mov     al,[col]
        mov     ah,al
        rep     stosw
      END;

CONST PelAddrRgR  = $3C7;
      PelAddrRgW  = $3C8;
      PelDataReg  = $3C9;

PROCEDURE SetCol(C, R, G, B : BYTE);
BEGIN
   Port[PelAddrRgW] := C;
   Port[PelDataReg] := R;
   Port[PelDataReg] := G;
   Port[PelDataReg] := B;
END;



PROCEDURE SetUpVirtual(VAR screenname:virscr;VAR add : word);
BEGIN
  GetMem (Screenname,64000);
  add := seg (Screenname^);
  clear(0,add);
END;

var
x,y,z,x1,y1,z1,ry,rx,rz,p,zoom,a,b,r,sp,x2,z2,y2:single;
i,j,t:integer;
cx,cz,cy:mas;
cosrx,sinrx,cosry,sinry,cosrz,sinrz:single;
offset_x,offset_y,offset_z:single;

procedure draw(x_scr,y_scr:integer;scale:single);
begin
cosrx:=cos(rx);sinrx:=sin(rx); {save cos/sin value}
cosry:=cos(ry);sinry:=sin(ry);
cosrz:=cos(rz);sinrz:=sin(rz);
sp:=sp+0.01;
r:=72*0.000000001-9;
for t:=1 to 60 do
for i:=1 to 6 do
for j:=1 to 10 do
begin
a:=i*6.28/360*38+sp;
b:=j*6.28/360*38+sp;
cx[t]:=r*cos(b)*cos(a);
cy[t]:=r*cos(b)*sin(a);
cz[t]:=r*sin(b);

{x2:=cx[t]; y2:=cy[t]; z2:=cz[t];
cx[t]:=x2*cos(sp)-y2*sin(sp);
cy[t]:=x2*sin(sp)+y2*cos(sp);
cz[t]:=z2;}
x1:=cosry*cx[t]-sinry*cz[t];
z1:=sinry*cx[t]+cosry*cz[t];
x:=cosrz*x1+sinrz*cy[t];
  y1:=cosrz*cy[t]-sinrz*x1;
  z:=cosrx*z1-sinrx*y1;
  y:=sinrx*z1+cosrx*y1;
  P:=z-120;
  x:=trunc(-(x*120)/P*scale)+x_scr;
  y:=trunc(-(y*120)/P*scale)+y_scr;
  if (x>0) and (x<320) and (y>0) and (y<200) then begin
   setpixel(trunc(x),trunc(y),trunc(z)+20,vaddr);
   end;
  end;
 end;


begin
SetUpVirtual(scr2,vaddr);{Getting memory for frame-buffer}


asm                      {Setup graphic mode 320x200x8bit}
mov ax,13h
int 10h
end;

          {Set vga-palette, two gradients White: 1..63, Blue: 64..128}
for n:=1 to 63 do SetCol(n,n,n,n);
for n:=1 to 63 do SetCol(n+63,n div 3, n div 3,n);


{---------------------Generating 3d-model-------------------------}


 
{---------------------End of generating 3d-model-------------------------}

Aantal:=0; T1:=Time;

repeat
roll:=roll+0.001;

clear(0,vaddr); {Clear framebuffer}

                {Value of rotate 3d}
rx:=cos(roll/5)*10;
ry:=sin(roll/3)*10;
rz:=-cos(roll/2)*10;

Draw(160,100,6); {draw 3d-masive}

WaitVR;          {Wait vertical retrace}

FlipScreen(vaddr,VGA); {Fast copy framebuffer to video-mem}

Inc(Aantal);    {this call nomber of frame, for calling fps}

until keypressed;
asm
mov ah,0
mov al,3
int 10h
end;

  T1:=Time-T1;   {Print FPS}
  WriteLn(Aantal/(T1/18.2) :1:2,' Frames per second');
end.
